; File:     Printer10.inc
; 
; 
WndProcA        proc    hWnd:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD

                mov     edx, wParam
                mov     eax, uMsg
                ;               
                cmp     eax, WM_COMMAND
                je      _iCmdProc               ; go to CmdProc           

                cmp     eax, WM_CLOSE
                je      _WM_CLOSE

                cmp     eax, WM_DESTROY
                je      _WM_DESTROY
                
                cmp     eax, WM_SYSCOMMAND
                je      _WM_SYSCOMMAND
                
                jmp     _EndProcA
; -----------------------------------------------------------------
;                             WM_SYSCOMMAND
; -----------------------------------------------------------------
_WM_SYSCOMMAND: cmp     edx, SC_CLOSE
                jne     _EndProcA
                ;jmp     _WM_CLOSE
; -----------------------------------------------------------------
;                             WM_CLOSE
; -----------------------------------------------------------------
_WM_CLOSE::     cmp     _hpdc, 0
                je      short @F
                ;
                invoke   DeleteDC, _hpdc
                ;
@@:             invoke    GlobalFree, _pFrmMem
                ;
                invoke   DestroyWindow,  hWnd
                jmp     _ExitProcA
; -----------------------------------------------------------------
;                             WM_DESTROY
; -----------------------------------------------------------------
_WM_DESTROY:    invoke   PostQuitMessage, NULL
                jmp     _ExitProcA 
                
; -----------------------------------------------------------------
_EndProcA::     invoke   DefWindowProc, hWnd, uMsg, wParam, lParam                
                ret
                ;
_ExitProcA::    mov     eax, 0
                ret
WndProcA        endp
;------------------------------------------------------------------------------------------------------------------****
; Aco:
;           converte a dword Val para DECIMAL e coloca na string RCL apontada
;           por pRcl. Termina a string com 0 e anula a string se o buffer
;           for insuficiente
;
OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE
CnvToRcl    proc    Val:DWORD, pRcl:DWORD
            push    ebx
            push    esi
            push    edi

            mov     eax, [esp+16]           ; Val
            mov     edi, [esp+20]           ; pBuf

            test    eax, eax
            jnz     short @F
            
            mov     dword ptr [edi - 4], 1
            mov     word ptr [edi], 30h
            mov     byte ptr [edi + 1], 0        ; terminate the string
            clc
            jnc     _exit

@@:
            mov     ecx, 3435973837
            xor     esi, esi
                        
@@:             mov     ebx, eax
                mul     ecx
                shr     edx, 3
                mov     eax, edx
                lea     edx, [edx*4+edx]
                add     edx, edx
                sub     ebx, edx
                add     bl, '0'
                ;
                push    ebx                 ; To stack
                add     esi, 1
            or      eax, eax
            jnz     short @B
            
            ; Buffer length control 
            cmp     esi, dword ptr [edi - 8]
            jbe     short _go
            ;
@@:         pop     eax                     ; Get from stack
            sub     esi, 1
            jnz     short @B            
            
            mov     dword ptr [edi - 4], 0
            mov     byte ptr [edi], 0           ; terminate the string            
            stc
            jc      short _exit
            ;
            
_go:        mov     dword ptr [edi - 4], esi
                         
@@:         pop     eax                     ; Get from stack
            mov     byte ptr [edi], al
            add     edi, 1
            sub     esi, 1
            jnz     short @B            

            mov     byte ptr [edi], 0           ; terminate the string
            clc
            
_exit:      pop     edi
            pop     esi
            pop     ebx
            ret     8
CnvToRcl    endp
;OPTION PROLOGUE:PrologueDef
;OPTION EPILOGUE:EpilogueDef
; 
;OPTION PROLOGUE:NONE
;OPTION EPILOGUE:NONE
RclRclCpy       proc    pRcl1:DWORD, pRcl2:DWORD

                mov     ebx, [esp + 4]              ; pRcl1
                mov     ecx, dword ptr [ebx- 4]
                ;
                mov     edx, [esp + 8]              ; pRcl2
                mov     dword ptr [edx - 4], ecx
                
@@:             sub     ecx, 1
                movzx   eax, byte ptr [ebx + ecx] 
                mov     byte ptr [edx + ecx], al
                jnz     short @B
                
                ret     8
RclRclCpy       endp
;OPTION PROLOGUE:PrologueDef
;OPTION EPILOGUE:EpilogueDef
; 
;OPTION PROLOGUE:NONE
;OPTION EPILOGUE:NONE
RclRclAdd       proc    pRcl1:DWORD, pRcl2:DWORD

                mov     ebx, [esp + 4]              ; pRcl1
                mov     ecx, dword ptr [ebx - 4]
                ;
                mov     edx, [esp + 8]              ; pRcl2
                mov     eax, dword ptr [edx - 4]                
                add     ecx, eax
                mov     dword ptr [edx - 4], ecx
                ;
                add     edx, eax
                mov     ecx, dword ptr [ebx - 4]                
                ;
@@:             sub     ecx, 1
                movzx   eax, byte ptr [ebx + ecx] 
                mov     byte ptr [edx + ecx], al
                jnz     short @B

                ret     8
RclRclAdd       endp
;OPTION PROLOGUE:PrologueDef
;OPTION EPILOGUE:EpilogueDef
; 
; Output:
;           EAX     - ponteiro
;
AllocMemo       proc        Bytes:DWORD        
                ;
                mov         eax, [esp + 4]          ; Bytes
                mov         ebx, eax
                ;
                invoke      GlobalAlloc, GMEM_FIXED, eax
                cmp         eax, NULL
                jne         short @F

                stc
                ret         4
                ;
@@:             sub         ebx, 1
                mov         dword ptr [eax + 0], ebx
                mov         dword ptr [eax + 4], 0
                mov         dword ptr [eax + ebx], 0    ; null terminator               
                clc
                ret         4
AllocMemo       endp
OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef
; ##############################################################################################

